Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 101013)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 101015)
@@ -828,5 +828,4 @@
 	src/globals/UIMessageCenter.h \
 	src/globals/UIModalWindowManager.h \
-	src/globals/UIPaneContainer.h \
 	src/globals/UIPopupCenter.h \
 	src/globals/UIProgressEventHandler.h \
@@ -963,4 +962,5 @@
 	src/widgets/UIMediumSizeEditor.h \
 	src/widgets/UIMenuBar.h \
+	src/widgets/UIPaneContainer.h \
 	src/widgets/UIPopupBox.h \
 	src/widgets/UIPopupPane.h \
@@ -1409,5 +1409,4 @@
 	src/globals/UIModalWindowManager.cpp \
 	src/globals/UIMousePointerShapeData.cpp \
-	src/globals/UIPaneContainer.cpp \
 	src/globals/UIPathOperations.cpp \
 	src/globals/UIPopupCenter.cpp \
@@ -1550,4 +1549,5 @@
 	src/widgets/UIMediumSizeEditor.cpp \
 	src/widgets/UIMenuBar.cpp \
+	src/widgets/UIPaneContainer.cpp \
 	src/widgets/UIPopupBox.cpp \
 	src/widgets/UIPopupPane.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPaneContainer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPaneContainer.cpp	(revision 101013)
+++ 	(revision )
@@ -1,111 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIVMLogViewer class implementation.
- */
-
-/*
- * Copyright (C) 2010-2023 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-/* Qt includes: */
-#include <QComboBox>
-#include <QHBoxLayout>
-#include <QLabel>
-#include <QPlainTextEdit>
-#include <QTextCursor>
-#include <QToolButton>
-
-/* GUI includes: */
-#include "QIToolButton.h"
-#include "UIIconPool.h"
-#include "UIPaneContainer.h"
-#ifdef VBOX_WS_MAC
-# include "VBoxUtils-darwin.h"
-#endif
-
-/* Other VBox includes: */
-#include <iprt/assert.h>
-
-UIPaneContainer::UIPaneContainer(QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QWidget>(pParent)
-    , m_pTabWidget(0)
-    , m_pCloseButton(0)
-{
-    prepare();
-    retranslateUi();
-}
-
-void UIPaneContainer::retranslateUi()
-{
-    if (m_pCloseButton)
-        m_pCloseButton->setToolTip(tr("Close"));
-}
-
-void UIPaneContainer::prepare()
-{
-    QHBoxLayout *pLayout = new QHBoxLayout(this);
-    AssertReturnVoid(pLayout);
-    pLayout->setContentsMargins(0, 0, 0, 0);
-    m_pTabWidget = new QTabWidget();
-    connect(m_pTabWidget, &QTabWidget::currentChanged, this, &UIPaneContainer::sigCurrentTabChanged);
-    AssertReturnVoid(m_pTabWidget);
-    pLayout->addWidget(m_pTabWidget);
-    /* Add a button to close the tab widget: */
-    m_pCloseButton = new QIToolButton;
-    AssertReturnVoid(m_pCloseButton);
-    m_pCloseButton->setIcon(UIIconPool::iconSet(":/close_16px.png"));
-    connect(m_pCloseButton, &QIToolButton::clicked, this, &UIPaneContainer::sltHide);
-
-    m_pTabWidget->setCornerWidget(m_pCloseButton);
-}
-
-void UIPaneContainer::sltHide()
-{
-    hide();
-    emit sigHidden();
-}
-
-void UIPaneContainer::insertTab(int iIndex, QWidget *pPage, const QString &strLabel /* = QString() */)
-{
-    if (m_pTabWidget)
-        m_pTabWidget->insertTab(iIndex, pPage, strLabel);
-}
-
-void UIPaneContainer::setTabText(int iIndex, const QString &strText)
-{
-    if (!m_pTabWidget || iIndex < 0 || iIndex >= m_pTabWidget->count())
-        return;
-    m_pTabWidget->setTabText(iIndex, strText);
-}
-
-void UIPaneContainer::setCurrentIndex(int iIndex)
-{
-    if (!m_pTabWidget || iIndex >= m_pTabWidget->count() || iIndex < 0)
-        return;
-    m_pTabWidget->setCurrentIndex(iIndex);
-}
-
-int UIPaneContainer::currentIndex() const
-{
-    if (!m_pTabWidget)
-        return -1;
-    return m_pTabWidget->currentIndex();
-}
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPaneContainer.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPaneContainer.h	(revision 101013)
+++ 	(revision )
@@ -1,78 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIVMLogViewer class declaration.
- */
-
-/*
- * Copyright (C) 2010-2023 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-#ifndef FEQT_INCLUDED_SRC_globals_UIPaneContainer_h
-#define FEQT_INCLUDED_SRC_globals_UIPaneContainer_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/* Qt includes: */
-#include <QWidget>
-#include <QKeySequence>
-/* GUI includes: */
-#include "QIWithRetranslateUI.h"
-
-/* Forward declarations: */
-class QHBoxLayout;
-class QIToolButton;
-
-
-/** QWidget extension acting as the base class for all the dialog panels like file manager, logviewer etc. */
-class SHARED_LIBRARY_STUFF UIPaneContainer : public QIWithRetranslateUI<QWidget>
-{
-    Q_OBJECT;
-
-signals:
-
-    void sigCurrentTabChanged(int iIndex);
-    void sigHidden();
-
-public:
-
-    UIPaneContainer(QWidget *pParent = 0);
-    void setCurrentIndex(int iIndex);
-    int currentIndex() const;
-
-protected:
-
-    virtual void prepare();
-    void insertTab(int iIndex, QWidget *pPage, const QString &strLabel = QString());
-    void setTabText(int iIndex, const QString &strText);
-    void retranslateUi() override;
-
-private slots:
-
-    void sltHide();
-
-private:
-
-    QTabWidget    *m_pTabWidget;
-    QIToolButton  *m_pCloseButton;
-};
-
-#endif /* !FEQT_INCLUDED_SRC_globals_UIPaneContainer_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPaneContainer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPaneContainer.cpp	(revision 101015)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPaneContainer.cpp	(revision 101015)
@@ -0,0 +1,113 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIVMLogViewer class implementation.
+ */
+
+/*
+ * Copyright (C) 2010-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+/* Qt includes: */
+#include <QComboBox>
+#include <QHBoxLayout>
+#include <QLabel>
+#include <QPlainTextEdit>
+#include <QTextCursor>
+#include <QToolButton>
+
+/* GUI includes: */
+#include "QIToolButton.h"
+#include "UIIconPool.h"
+#include "UIPaneContainer.h"
+#ifdef VBOX_WS_MAC
+# include "VBoxUtils-darwin.h"
+#endif
+
+/* Other VBox includes: */
+#include <iprt/assert.h>
+
+UIPaneContainer::UIPaneContainer(QWidget *pParent /* = 0 */)
+    : QIWithRetranslateUI<QWidget>(pParent)
+    , m_pTabWidget(0)
+    , m_pCloseButton(0)
+{
+    prepare();
+    retranslateUi();
+}
+
+void UIPaneContainer::retranslateUi()
+{
+    if (m_pCloseButton)
+        m_pCloseButton->setToolTip(tr("Close"));
+}
+
+void UIPaneContainer::prepare()
+{
+    QHBoxLayout *pLayout = new QHBoxLayout(this);
+    AssertReturnVoid(pLayout);
+    pLayout->setContentsMargins(0, 0, 0, 0);
+
+    /* Add the tab widget: */
+    m_pTabWidget = new QTabWidget();
+    connect(m_pTabWidget, &QTabWidget::currentChanged, this, &UIPaneContainer::sigCurrentTabChanged);
+    AssertReturnVoid(m_pTabWidget);
+    pLayout->addWidget(m_pTabWidget);
+
+    /* Add a button to close the tab widget: */
+    m_pCloseButton = new QIToolButton;
+    AssertReturnVoid(m_pCloseButton);
+    m_pCloseButton->setIcon(UIIconPool::iconSet(":/close_16px.png"));
+    connect(m_pCloseButton, &QIToolButton::clicked, this, &UIPaneContainer::sltHide);
+    m_pTabWidget->setCornerWidget(m_pCloseButton);
+}
+
+void UIPaneContainer::sltHide()
+{
+    hide();
+    emit sigHidden();
+}
+
+void UIPaneContainer::insertTab(int iIndex, QWidget *pPage, const QString &strLabel /* = QString() */)
+{
+    if (m_pTabWidget)
+        m_pTabWidget->insertTab(iIndex, pPage, strLabel);
+}
+
+void UIPaneContainer::setTabText(int iIndex, const QString &strText)
+{
+    if (!m_pTabWidget || iIndex < 0 || iIndex >= m_pTabWidget->count())
+        return;
+    m_pTabWidget->setTabText(iIndex, strText);
+}
+
+void UIPaneContainer::setCurrentIndex(int iIndex)
+{
+    if (!m_pTabWidget || iIndex >= m_pTabWidget->count() || iIndex < 0)
+        return;
+    m_pTabWidget->setCurrentIndex(iIndex);
+}
+
+int UIPaneContainer::currentIndex() const
+{
+    if (!m_pTabWidget)
+        return -1;
+    return m_pTabWidget->currentIndex();
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPaneContainer.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPaneContainer.h	(revision 101015)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPaneContainer.h	(revision 101015)
@@ -0,0 +1,78 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIVMLogViewer class declaration.
+ */
+
+/*
+ * Copyright (C) 2010-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+#ifndef FEQT_INCLUDED_SRC_widgets_UIPaneContainer_h
+#define FEQT_INCLUDED_SRC_widgets_UIPaneContainer_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* Qt includes: */
+#include <QWidget>
+#include <QKeySequence>
+/* GUI includes: */
+#include "QIWithRetranslateUI.h"
+
+/* Forward declarations: */
+class QHBoxLayout;
+class QIToolButton;
+
+
+/** QWidget extension acting as the base class for all the dialog panels like file manager, logviewer etc. */
+class SHARED_LIBRARY_STUFF UIPaneContainer : public QIWithRetranslateUI<QWidget>
+{
+    Q_OBJECT;
+
+signals:
+
+    void sigCurrentTabChanged(int iIndex);
+    void sigHidden();
+
+public:
+
+    UIPaneContainer(QWidget *pParent = 0);
+    void setCurrentIndex(int iIndex);
+    int currentIndex() const;
+
+protected:
+
+    virtual void prepare();
+    void insertTab(int iIndex, QWidget *pPage, const QString &strLabel = QString());
+    void setTabText(int iIndex, const QString &strText);
+    void retranslateUi() override;
+
+private slots:
+
+    void sltHide();
+
+private:
+
+    QTabWidget    *m_pTabWidget;
+    QIToolButton  *m_pCloseButton;
+};
+
+#endif /* !FEQT_INCLUDED_SRC_widgets_UIPaneContainer_h */